$(document).ready(function() {
	var socket = io.connect(':8080');
	socket.on('dice', function (data) {
		if(data.win == 0) var status = 'lose';
		else var status = 'win';
		
		var html = '';
		html += '<tr class="show">';
		html += '<td>'+ data.username +'</td>';
		html += '<td class="'+ status +'">'+ data.num +'</td>';
		html += '<td>'+ data.range +'</td>';
		html += '<td>'+ data.sum +' <i class="fas fa-coins"></i></td>';
		html += '<td>';
		html += '<div class="chance-bar">';
		html += '<span class="chance-bar-fill" style="width: '+ data.perc +'%"></span>';
		html += '</div>';
		html += '</td>';
		html += '<td class="'+ status +'">'+ data.win_sum +' <i class="fas fa-coins"></i></td>';
		html += '</tr>';
		$('#lastGame').prepend(html);
		if($('.show').length >= 20) $('.show:nth-child(21)').remove();
		$('.tooltip').tooltipster({
			side: 'bottom',
			theme: 'tooltipster-borderless'
		});
	});
	$('#final').html(((100 / $('#perc').val()) * $('#sum').val()).toFixed(0));
	$('#min').html('0 - ' + Math.floor(($('#perc').val() / 100) * 999999));
	$('#max').html(999999 - Math.floor(($('#perc').val() / 100) * 999999) + ' - 999999');
	$('#sum, #perc').keyup(function() {
		$('#final').html(((100 / $('#perc').val()) * $('#sum').val()).toFixed(0));
		$('#min').html('0 - ' + Math.floor(($('#perc').val() / 100) * 999999));
		$('#max').html(999999 - Math.floor(($('#perc').val() / 100) * 999999) + ' - 999999');
	});
	$('.type .but').click(function() {
		$.ajax({
			type: 'POST',
			url: '/action',
			data: {
				type: $(this).data('type'),
				sum: $('#sum').val(),
				perc: $('#perc').val(),
			},
			success: function(data) {
				var html = '';
				if(data.win == 0) html += "<div type='submit' class='lose'>Выпало "+ data.num +"</div>";
				if(data.win == 1) html += "<div type='submit' class='win'>Победа. Вы выиграли "+ data.win_sum +" <i class='fas fa-coins'></i></div>";
				$('#result').html(html);
				$('.tooltip').tooltipster({
					side: 'bottom',
					theme: 'tooltipster-borderless'
				});
			},
			error: function(data) {
				console.log(data);
			}
		});
	});
	$('#perc').on('change keydown paste input', function() {
        var perc = $(this).val();
        $('#range').val(perc);
		$('#final').html(((100 / perc) * $('#sum').val()).toFixed(0));
		$('#min').html('0 - ' + Math.floor((perc / 100) * 999999));
		$('#max').html(999999 - Math.floor((perc / 100) * 999999) + ' - 999999');
		perc = (perc/100)*118;
		$('#range').css({
			'background': '-webkit-linear-gradient(left, rgb(241, 2, 96) 0%, rgb(241, 2, 96) '+ perc +'%, rgb(8, 229, 71) '+ perc +'%, rgb(8, 229, 71) 85%)'
		});
    });
	$('#range').on('change keydown paste input', function() {
        var perc = $(this).val();
		if ($(this).val() > 85) $(this).val() = 85;
        $('#perc').val(perc);
		$('#final').html(((100 / perc) * $('#sum').val()).toFixed(0));
		$('#min').html('0 - ' + Math.floor((perc / 100) * 999999));
		$('#max').html(999999 - Math.floor((perc / 100) * 999999) + ' - 999999');
		perc = (perc/100)*118;
		$('#range').css({
			'background': '-webkit-linear-gradient(left, rgb(241, 2, 96) 0%, rgb(241, 2, 96) '+ perc +'%, rgb(8, 229, 71) '+ perc +'%, rgb(8, 229, 71) 100%)'
		});
    });
});
function perc(num) {
	if (num.value > 85) {
		num.value = 85;
	}
	if (num.value < 1) {
		num.value = 1;
	}
}
function minsum(num) {
	if (num.value < 10) {
		num.value = 10;
	}
}