$(document).ready(function() {
    var socket = io.connect(':8080');
    $('.chat-text').scrollTop(1e7);
    // Toastr
    socket.on('message', function(msg) {
        if(USER_ID == msg.user) {
            switch(msg.icon) {
                case 'success' :
                    $.notify({
                        position : 'bottom-left',
                        type: 'success',
                        message: msg.msg
                    });
                break;
                case 'error' :
                    $.notify({
                        position : 'bottom-left',
                        type: 'error',
                        message: msg.msg
                    });
                break;
                case 'info' :
                    $.notify({
                        position : 'bottom-left',
                        type: 'info',
                        message: msg.msg
                    });
                break;
            }
        }
    });
    
    // Update Balance
    socket.on('updateBalance', function(data) {
        if(USER_ID == data.id) $('.balance').text(data.balance);
    });
    
    // Online
    socket.on('online', function(data) {
        $('.online').text(data); 
    });
	
	socket.emit('chats');
	
	socket.on('chat', function (data) {
		msg = JSON.parse(data);
        var name = msg.username;
        if(msg.admin) {
            name = '<span style="color:red;">[Администратор]</span>';
        }
        if(msg.moder) {
            name = '<span style="color:red;"> ' + msg.username;
'</span>'
        }
        if(msg.youtuber) {
            name = '<span style="color:red;">' + msg.username;
'</span>'
        }
	var chat = $('.chat-cont');
		var messages = msg.messages;
		    chat.find('.chat-text').append(
			'<div class="item" id="chatm_"' + msg.user_id + '">' +
            	'<div class="sub-heading clear">' +
            		'<div class="avatar"><img src="' + msg.avatar + '" alt=""></div>' +
                    '<div class="name" onclick="var u = $(this); $(\'.chatForm .message\').val(u.text() + \', \'); return false;">' + name + '</div>' +
                    '<div class="date"><span>' + msg.user_id + '</span></div>' +
                '</div>' +
                '<div class="text">' + messages + '</div>' +
            '</div>');

	
		
		$('.chat-text').scrollTop(1e7);
        $('.message:nth-child(1)').remove();
	});
    
	socket.on('clear', function (data) {
		$('.chat-text').text('');
	});
	
    /* CHAT */
	$('#chatinput').bind("enterKey", function (e) {
        var input = $(this);
        var msg = input.val();
        if (msg != '') {
            $.post('/chat', {messages: msg}, function (data) {
                if (data) {
                    if (data.status == 'success') {
                        input.val('');
                    } else {
						input.val('');
                    }
                    $.notify({
                        position : 'bottom-left',
                        type: data.status,
                        message: data.message
                    });
                }
                else
                    input.val('');
            });
        }
    });

    $('#chatinput').keyup(function (e) {
        if (e.keyCode == 13) {
            $(this).trigger("enterKey");
        }
    });
    $('#chatsend').on('click', function (event) {
        $('#chatinput').trigger("enterKey");
    });
    /* CHAT */
});