$(document).ready(function() {
    var socket = io.connect(':8080');
    
    // Редактирование суммы ставки
    $('.cont').click(function() {
        var value = parseFloat($('#insumm').val());
        if(isNaN(value)) value = '';
        switch($(this).attr('data-method')) {
            case 'plus' : 
                value += parseFloat($(this).attr('data-value'));
            break;
            case 'multiply' :
                value = value*parseFloat($(this).attr('data-value'));
            break;
            case 'last' :
                value = localStorage.getItem('doubleValue');
            break;
            case 'clear' :
                value = '';
            break;
            case 'divide' :
                value = value/parseFloat($(this).attr('data-value'));
            break;
            case 'all' :
                value = $('.stavbut .balance').text();
            break;
        }
        $('#insumm').val(value);
    });
    
    // Ставка
    $('.betButton').click(function() {
        var value = parseFloat($('#insumm').val());
        localStorage.setItem('doubleValue', value);
        if(isNaN(value)) {
			$.notify({
                position : 'bottom-left',
                type: 'error',
                message: 'Вы забыли указать сумму!'
            });
            return;
        }
        if(typeof $(this).attr('data-bet-type') == 'undefined') {
            $.notify({
                position : 'bottom-left',
                type: 'error',
                message: 'Не удалось определить цвет, на который вы ставите.'
            });
            return;
        }
        $.ajax({
            url : '/addBetDouble',
            type : 'post',
            data : {
                value : value,
                type : $(this).attr('data-bet-type')
            },
            success : function(data) {
                $.notify({
                    position : 'bottom-left',
                    type: data.status,
                    message: data.message
                });
                $('#insumm').val('');
            },
            error : function(data) {
				$.notify({
                    position : 'bottom-left',
                    type: 'error',
                    message: 'Ошибка!'
                });
            }
        });
    });
    
    // Новая ставка
    socket.on('double.newBet', function(data) {
		var bet = '<div class="rates-i" data-userid="' + data.user_id + '"> 			
                <div class="rates-ava"> 						<img src="' + data.avatar + '"> 					</div> 	
                 <div class="hidden"> 						<div class="rates-login"><b class="ell">' + data.username + '
</b></div> 			

                   <div class="rates-rub">' + data.value + '</div> 					 			</div> 		</div>';
        
        $('#bank_red').text(data.global.red);
        $('#bank_green').text(data.global.green);
        $('#bank_black').text(data.global.black);
        
        var list = $('.betButton');
        for(var i = 0; i < list.length; i++) {
            var typeName = $(list[i]).attr('data-bet-type');
            if(typeName == data.type) {
                $('.rates-content_'+data.type).prepend(bet);
            }
        }
    });
    
    // Таймер
    socket.on('double.timer', function(data) {
        if(data < 10) data = '0' + data; 
        $('#rez-numbr').text(data);
    });
    
    // Крутим барабан
    socket.on('double.showSlider', function(data) {
        $('#reletteact').css({'transform': 'rotate('+data.rotate+'deg)', 'transition': 'transform 10s cubic-bezier(0.15, 0.15, 0, 1)'});
        $('#rez-numbr').hide();
        setTimeout(function() {
            $('#rez-numbr').show();
            $('#rez-numbr').text(data.number);
            if(data.color == 'red') {
                $('#rez-numbr').css({color: 'rgb(226, 18, 72)'});
            } else if(data.color == 'green') {
                $('#rez-numbr').css({color: 'rgb(28, 195, 69)'});
            } else {
                $('#rez-numbr').css({color: 'rgb(70, 70, 70)'});
            }
			$('.double-rel').show().css({background: data.color}).text(data.number);
            $('.overlastpick').prepend('<div class="left bg'+ data.color +'">'+data.number+'</div>');
            var list = $('.rates-loop');
            for(var i = 0; i < list.length; i++) {
                if($(list[i]).attr('data-type') != data.color) {
                    $(list[i]).find('.rates-top').find('.bet').countTo({
                        from : parseFloat($(list[i]).find('.rates-top').find('.bet').text()),
                        to : 0,
                        speed : 1000
                    });
                } else {
                    $(list[i]).find('.rates-top').find('.bet').countTo({
                        from : parseFloat($(list[i]).find('.rates-top').find('.bet').text()),
                        to : data.winner_value,
                        speed : 1000
                    }); 
                }
            }
        }, 10000);
    });
    
    
    // Новый раунд
    socket.on('double.newGame', function(data) {
        $('#rez-numbr').removeAttr('style');
		$('.double-rel').hide().css({background: 'none'}).text('');
        $('#rez-numbr').text(data.time);
        $('.rates-content_red').html('');
        $('.rates-content_green').html('');
        $('.rates-content_black').html('');
        $('#bank_red').text('0');
        $('#bank_green').text('0');
        $('#bank_black').text('0');
    });

});