var spinArray = ['animation2160'];
$(document).ready(function() {	
    var socket = io.connect(':8080');
    
	socket.on('new.flip', function (data) {
		$('.flip-rooms').append(data.html);
	});
    
	socket.on('end.flip', function (data) {
		$('.flip_'+ data.game.id).remove();
		var html = '';
			html += '<div class="flip-block_'+ data.game.id +'" style="display:block">';
			html += '<div class="game">';
			html += '<div class="game_title_bg">Игра #<span>'+ data.game.id +'</span></div>';
			html += '<div class="gameinfo"><div class="user_1">'+ data.user1.username +'</div><div class="vs">VS</div><div class="user_2">'+ data.user2.username +'</div></div>';
			html += '<div id="timer_'+ data.game.id +'"><div class="time"><span id="count_num_'+ data.game.id +'">5</span></div></div>';
			html += '<div id="coin-flip-cont_'+ data.game.id +'" style="display: none;"><div id="coin_'+ data.game.id +'"><div class="front"><img src="'+ data.winner.avatar +'"></div><div class="back"><img src="'+ data.loser.avatar +'"></div></div></div>';
			html += '</div>';
			html += '<div class="roominfo"><div class="totalm">На кону: <span>'+ data.game.price +'</span> pt.</div><div class="winner">Победитель: <span>...</span></div></div>';
			html += '</div>';
		
		$('.flip-last').prepend(html);
		setTimeout(function() {
			handleTimer(data.game.id);
		}, 2000);
		setTimeout(function() {
			$('.flip-block_'+ data.game.id +' .roominfo .winner span').text(data.winner.username);
			$('.flip-block_'+ data.game.id +' .game .front').addClass('winner_a');
		}, 13000);
		$('.flip-block:nth-child(10)').remove(); 
	});
	
    // Редактирование суммы ставки
    $('.flip-panel a').click(function() {
        var value = parseFloat($('#insumm').val());
        if(isNaN(value)) value = 0;
        switch($(this).attr('data-method')) {
            case 'plus' : 
                value += parseFloat($(this).attr('data-value'));
            break;
            case 'multiply' :
                value = value*parseFloat($(this).attr('data-value'));
            break;
            case 'clear' :
                value = 0;
            break;
            case 'divide' :
                value = value/parseFloat($(this).attr('data-value'));
            break;
            case 'all' :
                $.ajax({
                    url     : '/getBalanceByUserId',
                    type    : 'post',
                    success : function(data) {
                        $('#insumm').val(data);
                    },
                    error   : function(e) {
                        $.notify({
                            position : 'bottom-left',
                            type: 'error',
                            message: 'Ошибка! Попробуйте чуть позже.'
                        });
                        console.log(e.responseText);
                    }  
                });
                return;
            break;
        }
        $('#insumm').val(Math.floor(value));
    });
});

function createRoom() {
	var value = parseFloat($('#insumm').val());
	if(isNaN(value)) {
        $.notify({
            position : 'bottom-left',
            type: 'error',
            message: 'Вы забыли указать сумму!'
        });
		return;
	} 
	$.ajax({
		url : '/flip/newGame',
		type : 'post',
		data : {
			value : value

		},
		success : function(data) {
			$('#insumm').val('');
			if (data.type == 'success') {
                $.notify({
                    position : 'bottom-left',
                    type: 'success',
                    message: data.msg
                });
			}
			if (data.type == 'error') {
                $.notify({
                    position : 'bottom-left',
                    type: 'error',
                    message: data.msg
                });
			}
		},
		error : function(data) {
			console.log(data.responseText);
            $.notify({
                position : 'bottom-left',
                type: 'error',
                message: 'Ошибка!'
            });
		}
	});
}

function joinRoom(id) {
	$.ajax({
		url: '/flip/joinRoom',
		data: {
			id: id
		},
		type: 'POST',
		dataType: 'JSON',
		success: function (data) {
			$('#insumm').val('');
			if (data.type == 'success') {
                $.notify({
                    position : 'bottom-left',
                    type: 'success',
                    message: data.msg
                });
			}
			if (data.type == 'error') {
                $.notify({
                    position : 'bottom-left',
                    type: 'error',
                    message: data.msg
                });
			}
		}

	});
}

function getSpin() {
    var spin = spinArray[Math.floor(Math.random() * spinArray.length)];
    return spin;
}

function handleTimer(id) {
    var countdownElement = document.getElementById('count_num_'+id),
        seconds = 5,
        second = 0,
        interval;

    interval = setInterval(function() {
        countdownElement.firstChild.data = (seconds - second);
        if (second >= seconds) {
			$('#timer_'+id).hide();
			$('#coin-flip-cont_'+id).show();
            $('#coin_'+id).addClass(getSpin());
            clearInterval(interval);
			setInterval(function() {
				$('.flip-block_'+id+' .front').addClass('winner_a');
			}, 4000);
        }
        second++;
    }, 1000);
}