$(document).ready(() => {
    window.socket = io.connect('https://live-loto.com:2083');
    window.double = {};

    socket.on('roulette', (res) => {
        $('#rez-numbr').removeAttr('style');
        if(res.type == 'timer') $('#rez-numbr').text((res.time > 9) ? res.time : '0'+res.time); 
        if(res.type == 'slider')
        {
            $('#rez-numbr').hide();
            $('#reletteact').css({
                'transition' : 'transform '+res.slider.time+'ms ease',
                'transform' : 'rotate('+res.slider.rotate+'deg)'
            });
            setTimeout(() => {
                $('#rez-numbr').show();
                $('#rez-numbr').text(res.slider.num);
                if(res.slider.color == 'red') {
                    $('#rez-numbr').css({color: 'rgb(226, 18, 72)'});
                } else if(res.slider.color == 'green') {
                    $('#rez-numbr').css({color: 'rgb(28, 195, 69)'});
                } else {
                    $('#rez-numbr').css({color: 'rgb(70, 70, 70)'});
                }
            }, res.slider.time);
        }
        if(res.type == 'newGame') 
        {
            $('.overlastpick').prepend('<div class="left bg'+res.history.color+'">'+res.history.num+'</div>')
            $('.prices').text(0);
            $('.bets').slideUp(200, () => {
                $('.bets').html('');
                $('.bets').show();
            });
            $('#reletteact').css({
                'transition' : 'transform 0s linear',
                'transform' : 'rotate('+res.slider.rotate+'deg)'
            });
            $('#rez-numbr').text(res.slider.time);
        }
        if(res.type == 'bets') return double.makeBets(res.bets, res.prices);
    });

    double.makeBets = function(bets, prices)
    {
        var colors = [];
        for(var i in bets)
        {
            let bet = bets[i];
            if(typeof colors[bet.type] == 'undefined') colors[bet.type] = '';
            colors[bet.type] += '<div class="undr-coin coinflip-round zg1" data-userid="'+bet.user_id+'"><div class="left img-chat"> <img src="'+bet.avatar+'"></div><p class="top-text-chat left"> '+bet.username+'</p><div class="right text-a-chat"><div class="coid"><p class="inl"> <span>'+bet.value+'</span></p><div class="inl coinico"> <img src="img/coins.png" width="15"></div></div></div><div class="clear"></div></div>'
        }

        for(var color in colors) 
        {
            $('.rates-content_'+ color).html(colors[color]);
            $('#bank_' + color).text((typeof prices[color] == 'undefined') ? '0' : prices[color]);
        }
    }

    double.getMyBet = function(type, callback) {
        $.ajax({
            url : '/roulette/getBet',
            type : 'post',
            data : {
                type : type
            },
            success : (res) => {
                callback(res);
            },
            error : (err) => {
                console.log(err.responseText);
                callback(0);
            }  
        });
    }

    double.addBet = function() {
        let value = parseInt($('#insumm').val());
        if(isNaN(value)) return $.notify({
            position : 'bottom-left',
            type: 'error',
            message: 'Неверно введена сумма ставки'
        });

        $.ajax({
            url : '/roulette/addBet',
            type : 'post',
            data : {
                bet : value,
                type : $(this).attr('data-bet-type')
            },
            success : (res) => {
                $.notify({
                    position : 'bottom-left',
                    type: (res.success) ? 'success' : 'error',
                    message: res.msg
                });
                $('#insumm').val('');
            },
            error : (err) => {
                $.notify({
                    position : 'bottom-left',
                    type: 'error',
                    message: 'Ошибка при отправке данных на сервер'
                });
            }
        });
    }

    double.valueChange = async function() {
        let value = parseFloat($('#insumm').val()) || 0,
            thisMethod = $(this).parent().attr('data-method'),
            thisValue = parseFloat($(this).parent().attr('data-value'));

        switch(thisMethod) {
            case 'plus' : 
                value += thisValue;
                break;
            case 'divide' :
                value = parseInt((value/thisValue).toFixed(0));
                break;
            case 'clear' :
                value = '';
                break;
            case 'last' : 
                var last = new Promise((res, rej) => {
                    double.getMyBet('last', (val) => {
                        res(val);
                    });
                });
                value = await last;
                break;
            case 'all' : 
                let all = new Promise((res, rej) => {
                    double.getMyBet('all', (val) => {
                        res(val);
                    });
                });
                value = await all;
                break;
            case 'multiply' :
                value *= thisValue;
                break;
        }

        $('#insumm').val(value);
    }

    $('.sum-st .vv').click(double.valueChange);
    $('.betButton').click(double.addBet);

});