@extends('panel')

@section('content')
<div class="page-bar">
	<ul class="page-breadcrumb">
		<li>
			<a href="/admin">Главная</a>
			<i class="fa fa-circle"></i>
		</li>
		<li>
			<span>Промокоды</span>
		</li>
	</ul>
</div>

<h1 class="page-title"> Промокоды </h1>
<div class="flash-message">
    @foreach (['danger', 'warning', 'success', 'info'] as $msg)
      @if(Session::has('alert-' . $msg))

      <p class="alert alert-{{ $msg }}">{{ Session::get('alert-' . $msg) }} <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a></p>
      @endif

    @endforeach

        <div id="createPromo" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="createPromoLabel" aria-hidden="true">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                                    <h5 class="modal-title" id="myModalLabel">Новый промокод</h5>
                                </div>
                                <form action="/admin/promoNew" method="post">
                                    <div class="modal-body">
                                        <div class="form-group">
                                            <label for="recipient-name" class="control-label mb-10">Код (только английские символы):</label>
                                            <input type="text" class="form-control" name="code" placeholder="Код">
                                        </div>
                                        <div class="form-group">
                                            <label for="message-text" class="control-label mb-10">Лимит:</label>
                                            <select class="form-control" name="limit">
                                                <option value="0">Без лимита</option>
                                                <option value="1">По кол-ву</option>
                                            </select>
                                        </div>
                                        <div class="form-group">
                                            <label for="recipient-name" class="control-label mb-10">Сумма (в монетах):</label>
                                            <input type="text" class="form-control" name="amount" placeholder="Сумма">
                                        </div>
                                        <div class="form-group">
                                            <label for="recipient-name" class="control-label mb-10">Кол-во:</label>
                                            <input type="text" class="form-control" name="count_use" placeholder="Кол-во">
                                        </div>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn btn-default" data-dismiss="modal">Закрыть</button>
                                        <button type="submit" class="btn btn-success">Создать</button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                    @foreach($codes as $code)
                    <div id="editPromo{{$code->id}}" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="createPromoLabel" aria-hidden="true">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                                    <h5 class="modal-title" id="myModalLabel">Редактировать промокод</h5>
                                </div>
                                <form action="/admin/promoSave" method="post">
                                    <div class="modal-body">
                                        <input type="hidden" value="{{$code->id}}" name="id">
                                        <div class="form-group">
                                            <label for="recipient-name" class="control-label mb-10">Код (только английские символы):</label>
                                            <input type="text" class="form-control" name="code" placeholder="Код" value="{{$code->code}}">
                                        </div>
                                        <div class="form-group">
                                            <label for="message-text" class="control-label mb-10">Лимит:</label>
                                            <select class="form-control" name="limit">
                                                <option value="0" @if($code->limit == 0) selected @endif>Без лимита</option>
                                                <option value="1" @if($code->limit == 1) selected @endif>По кол-ву</option>
                                            </select>
                                        </div>
                                        <div class="form-group">
                                            <label for="recipient-name" class="control-label mb-10">Сумма (в монетах):</label>
                                            <input type="text" class="form-control" name="amount" placeholder="Сумма" value="{{$code->amount}}">
                                        </div>
                                        <div class="form-group">
                                            <label for="recipient-name" class="control-label mb-10">Кол-во:</label>
                                            <input type="text" class="form-control" name="count_use" placeholder="Кол-во" value="{{$code->count_use}}">
                                        </div>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn btn-default" data-dismiss="modal">Закрыть</button>
                                        <button type="submit" class="btn btn-success">Сохранить</button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                    @endforeach
</div> <!-- end .flash-message -->
    
<div class="row">

	<div class="col-md-12">

		<div class="portlet light bordered">
			<div class="portlet-body">
<div class="text-center">
                        <a class="btn btn-success btn-rounded" data-toggle="modal" data-target="#createPromo">Создать промокод</a>
                    </div>
				<table id="example" class="table table-striped table-bordered" cellspacing="0" width="100%">
    
					<thead>
						<tr>
							<th>Код</th>
				<th>Лимит</th>
				<th>Сумма</th>
<th>Активировало</th>
<th>Действие</th>
						</tr>
					</thead>
					<tbody>
						@foreach($codes as $code)
			  <tr>
				  <td>{{$code->code}}</td>
				  <td>@if($code->limit) По кол-ву @else Без лимита @endif</td>
				  <td>{{$code->amount}} rub</td>
<td>{{$code->count_use}}</td>
         <td class="text-center"><a class="btn btn-primary btn-rounded btn-xs" data-toggle="modal" data-target="#editPromo{{$code->id}}">Редактировать</a> / <a href="/admin/promoDelete/{{$code->id}}" class="btn btn-danger btn-rounded btn-xs">Удалить</a></td>
			  </tr>
			@endforeach

					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>
@endsection